#include <string>
#include <iostream>
#include <pthread.h>
#include <fstream>
#include <unistd.h>

#define STRING	std::string
#define CIN	std::cin
#define COUT	std::cout
#define ENDL	std::endl

const int iterations = 10;
const int thread_count = 5;
bool choosing[thread_count];
int number[thread_count];
int tempnum[thread_count];

std::ofstream logfile;

int max()
{
	int retval = 0;
	
	for( int i; i < thread_count; i++)
	{
		if(number[i] > retval)
			retval = number[i];
	}

	return retval;
}

void *runner(void *parameter)
{
	int i = *(int *)parameter;
	logfile << "! Entering Thread# " << i << ENDL;

	for(int it = 0; it < iterations; it++)
	{
		choosing[i] = true;
		number[i] = max() + 1;
		choosing[i] = false;
		logfile << "Thread# " << i << " wants to enter critical section with number " << number[i] << ENDL;
		usleep(1000);
		
		for(int j = 0; j < thread_count; j++)
		{
			while(choosing[j]);
			while((number[j]!=0) && (number[j] < number[i] || (number[j] == number[i] && j < i)));
		}

		logfile << "<< Thread# " << i << " is in critical section" << ENDL;
		usleep(1000);

		logfile << ">> Thread# " << i << " leaved critical section" << ENDL;
		number[i] = 0;
		usleep(1000);
	}

	return NULL;
}

int main()
{
	logfile.open("logfile");
	
	for(int i = 0; i < thread_count; i++)
	{
		logfile << "! Initializing choosing and number for " << i << ENDL;
		choosing[i] = false;
		number[i] = 0;
		tempnum[i] = i;
	}
	
	pthread_t thread_id[thread_count];

	for(int i = 0; i < thread_count; i++)
	{
		logfile << "! Creating Thread for " << i << ENDL;	
		pthread_create(&thread_id[i], NULL, &runner, &tempnum[i]);
	}

	for(int i = 0; i < thread_count; i++)
	{
		logfile << "! Waiting for Thread# " << i << ENDL;	
		pthread_join(thread_id[i], NULL);
	}

	logfile.close();
	return 0;
}


